// fullctrl.h : Declaration of the Cfullctrl

#ifndef __FULLCTRL_H_
#define __FULLCTRL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


class Cfullctrl;

class CWinHidden : 
	public CWindowImpl<CWinHidden, CWindow, CNullTraits>
	{
		BEGIN_MSG_MAP(CWinHidden)
		MESSAGE_HANDLER(WM_TIMECHANGE, OnTimeChange)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		END_MSG_MAP()
	public:
		//CWinHidden() {};
		CWinHidden(Cfullctrl* pFullCtrl) : m_pFullCtrl(pFullCtrl) {};

		LRESULT OnTimeChange(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
		{
			// TODO : Add Code for message handler. Call DefWindowProc if necessary.
			return 0;
		}
	public:
		LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	private:
		Cfullctrl*	m_pFullCtrl;
	};

/////////////////////////////////////////////////////////////////////////////
// Cfullctrl
class ATL_NO_VTABLE Cfullctrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<Ifullctrl, &IID_Ifullctrl, &LIBID_HIDDEN1Lib>,
	public CComControl<Cfullctrl>,
	public IPersistStreamInitImpl<Cfullctrl>,
	public IOleControlImpl<Cfullctrl>,
	public IOleObjectImpl<Cfullctrl>,
	public IOleInPlaceActiveObjectImpl<Cfullctrl>,
	public IViewObjectExImpl<Cfullctrl>,
	public IOleInPlaceObjectWindowlessImpl<Cfullctrl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<Cfullctrl>,
	public IPersistStorageImpl<Cfullctrl>,
	public ISpecifyPropertyPagesImpl<Cfullctrl>,
	public IQuickActivateImpl<Cfullctrl>,
	public IDataObjectImpl<Cfullctrl>,
	public IProvideClassInfo2Impl<&CLSID_fullctrl, &DIID__IfullctrlEvents, &LIBID_HIDDEN1Lib>,
	public IPropertyNotifySinkCP<Cfullctrl>,
	public CComCoClass<Cfullctrl, &CLSID_fullctrl>
{
	CWinHidden m_wndHidden;
	HWND m_hHidden;
	UINT	m_uintTimer;
public:
	Cfullctrl() : m_wndHidden(this)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_FULLCTRL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cfullctrl)
	COM_INTERFACE_ENTRY(Ifullctrl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(Cfullctrl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(Cfullctrl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(Cfullctrl)
	CHAIN_MSG_MAP(CComControl<Cfullctrl>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_TIMER, OnTimer)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	HRESULT FinalConstruct();
	void FinalRelease();


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_Ifullctrl,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// Ifullctrl
public:

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("ATL 3.0 : fullctrl");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}
	LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		return 0;
	}
};

#endif //__FULLCTRL_H_
